/* info-notification.c generated by valac 0.56.12, the Vala compiler
 * generated from info-notification.vala, do not modify */

/*
 * Copyright 2015 Canonical Ltd.
 * Copyright 2021 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Charles Kerr <charles.kerr@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <libnotify/notify.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define INDICATOR_SOUND_TYPE_NOTIFICATION (indicator_sound_notification_get_type ())
#define INDICATOR_SOUND_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotification))
#define INDICATOR_SOUND_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))
#define INDICATOR_SOUND_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))

typedef struct _IndicatorSoundNotification IndicatorSoundNotification;
typedef struct _IndicatorSoundNotificationClass IndicatorSoundNotificationClass;
typedef struct _IndicatorSoundNotificationPrivate IndicatorSoundNotificationPrivate;

#define INDICATOR_SOUND_TYPE_INFO_NOTIFICATION (indicator_sound_info_notification_get_type ())
#define INDICATOR_SOUND_INFO_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotification))
#define INDICATOR_SOUND_INFO_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotificationClass))
#define INDICATOR_SOUND_IS_INFO_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION))
#define INDICATOR_SOUND_IS_INFO_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION))
#define INDICATOR_SOUND_INFO_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotificationClass))

typedef struct _IndicatorSoundInfoNotification IndicatorSoundInfoNotification;
typedef struct _IndicatorSoundInfoNotificationClass IndicatorSoundInfoNotificationClass;
typedef struct _IndicatorSoundInfoNotificationPrivate IndicatorSoundInfoNotificationPrivate;
enum  {
	INDICATOR_SOUND_INFO_NOTIFICATION_0_PROPERTY,
	INDICATOR_SOUND_INFO_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* indicator_sound_info_notification_properties[INDICATOR_SOUND_INFO_NOTIFICATION_NUM_PROPERTIES];
typedef enum  {
	VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE
} VolumeControlActiveOutput;

#define VOLUME_CONTROL_TYPE_ACTIVE_OUTPUT (volume_control_active_output_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _IndicatorSoundNotification {
	GObject parent_instance;
	IndicatorSoundNotificationPrivate * priv;
	NotifyNotification* _notification;
};

struct _IndicatorSoundNotificationClass {
	GObjectClass parent_class;
	NotifyNotification* (*create_notification) (IndicatorSoundNotification* self);
};

struct _IndicatorSoundInfoNotification {
	IndicatorSoundNotification parent_instance;
	IndicatorSoundInfoNotificationPrivate * priv;
};

struct _IndicatorSoundInfoNotificationClass {
	IndicatorSoundNotificationClass parent_class;
};

static gpointer indicator_sound_info_notification_parent_class = NULL;

VALA_EXTERN GType indicator_sound_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundNotification, g_object_unref)
VALA_EXTERN GType indicator_sound_info_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundInfoNotification, g_object_unref)
VALA_EXTERN NotifyNotification* indicator_sound_notification_create_notification (IndicatorSoundNotification* self);
static NotifyNotification* indicator_sound_info_notification_real_create_notification (IndicatorSoundNotification* base);
VALA_EXTERN GType volume_control_active_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void indicator_sound_info_notification_show (IndicatorSoundInfoNotification* self,
                                             VolumeControlActiveOutput active_output,
                                             gdouble volume,
                                             gboolean is_high_volume);
VALA_EXTERN gboolean indicator_sound_notification_notify_server_supports (IndicatorSoundNotification* self,
                                                              const gchar* cap);
static const gchar* indicator_sound_info_notification_get_notification_label (VolumeControlActiveOutput active_output);
static const gchar* indicator_sound_info_notification_get_volume_notification_icon (VolumeControlActiveOutput active_output,
                                                                             gdouble volume,
                                                                             gboolean is_high_volume);
static GVariant* _variant_new1 (const gchar* value);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (const gchar* value);
static GVariant* _variant_new4 (gint32 value);
VALA_EXTERN void indicator_sound_notification_show_notification (IndicatorSoundNotification* self);
static const gchar* indicator_sound_info_notification_get_volume_icon (VolumeControlActiveOutput active_output,
                                                                gdouble volume);
VALA_EXTERN IndicatorSoundInfoNotification* indicator_sound_info_notification_new (void);
VALA_EXTERN IndicatorSoundInfoNotification* indicator_sound_info_notification_construct (GType object_type);
VALA_EXTERN IndicatorSoundNotification* indicator_sound_notification_construct (GType object_type);
static GType indicator_sound_info_notification_get_type_once (void);

static NotifyNotification*
indicator_sound_info_notification_real_create_notification (IndicatorSoundNotification* base)
{
	IndicatorSoundInfoNotification * self;
	NotifyNotification* _tmp0_;
	NotifyNotification* result;
	self = (IndicatorSoundInfoNotification*) base;
	_tmp0_ = notify_notification_new (_ ("Volume"), "", "audio-volume-muted");
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GVariant*
_variant_new1 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new2 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new3 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new4 (gint32 value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

void
indicator_sound_info_notification_show (IndicatorSoundInfoNotification* self,
                                        VolumeControlActiveOutput active_output,
                                        gdouble volume,
                                        gboolean is_high_volume)
{
	const gchar* volume_label = NULL;
	const gchar* _tmp0_;
	const gchar* icon = NULL;
	const gchar* _tmp1_;
	NotifyNotification* n = NULL;
	NotifyNotification* _tmp2_;
	NotifyNotification* _tmp3_;
	NotifyNotification* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	NotifyNotification* _tmp7_;
	NotifyNotification* _tmp8_;
	GVariant* _tmp9_;
	NotifyNotification* _tmp10_;
	GVariant* _tmp11_;
	const gchar* _tmp12_ = NULL;
	NotifyNotification* _tmp13_;
	GVariant* _tmp14_;
	NotifyNotification* _tmp15_;
	GVariant* _tmp16_;
	g_return_if_fail (self != NULL);
	if (!indicator_sound_notification_notify_server_supports ((IndicatorSoundNotification*) self, "x-canonical-private-synchronous")) {
		return;
	}
	_tmp0_ = indicator_sound_info_notification_get_notification_label (active_output);
	volume_label = _tmp0_;
	_tmp1_ = indicator_sound_info_notification_get_volume_notification_icon (active_output, volume, is_high_volume);
	icon = _tmp1_;
	_tmp2_ = ((IndicatorSoundNotification*) self)->_notification;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	n = _tmp3_;
	_tmp4_ = n;
	_tmp5_ = volume_label;
	_tmp6_ = icon;
	notify_notification_update (_tmp4_, _ ("Volume"), _tmp5_, _tmp6_);
	_tmp7_ = n;
	notify_notification_clear_hints (_tmp7_);
	_tmp8_ = n;
	_tmp9_ = _variant_new1 ("true");
	notify_notification_set_hint (_tmp8_, "x-lomiri-non-shaped-icon", _tmp9_);
	_g_variant_unref0 (_tmp9_);
	_tmp10_ = n;
	_tmp11_ = _variant_new2 ("true");
	notify_notification_set_hint (_tmp10_, "x-canonical-private-synchronous", _tmp11_);
	_g_variant_unref0 (_tmp11_);
	if (is_high_volume) {
		_tmp12_ = "true";
	} else {
		_tmp12_ = "false";
	}
	_tmp13_ = n;
	_tmp14_ = _variant_new3 (_tmp12_);
	notify_notification_set_hint (_tmp13_, "x-lomiri-value-bar-tint", _tmp14_);
	_g_variant_unref0 (_tmp14_);
	_tmp15_ = n;
	_tmp16_ = _variant_new4 (CLAMP ((gint32) ((volume * 100.0) + 0.5), (gint32) 0, (gint32) 100));
	notify_notification_set_hint (_tmp15_, "value", _tmp16_);
	_g_variant_unref0 (_tmp16_);
	indicator_sound_notification_show_notification ((IndicatorSoundNotification*) self);
	_g_object_unref0 (n);
}

static const gchar*
indicator_sound_info_notification_get_notification_label (VolumeControlActiveOutput active_output)
{
	const gchar* result;
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		{
			result = _ ("Speakers");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		{
			result = _ ("Headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		{
			result = _ ("Bluetooth headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		{
			result = _ ("Bluetooth speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		{
			result = _ ("Usb speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		{
			result = _ ("Usb headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		{
			result = _ ("HDMI speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			result = _ ("HDMI headphones");
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

static const gchar*
indicator_sound_info_notification_get_volume_notification_icon (VolumeControlActiveOutput active_output,
                                                                gdouble volume,
                                                                gboolean is_high_volume)
{
	const gchar* result;
	if (!is_high_volume) {
		const gchar* _tmp0_;
		_tmp0_ = indicator_sound_info_notification_get_volume_icon (active_output, volume);
		result = _tmp0_;
		return result;
	}
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			result = "audio-volume-high";
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

static const gchar*
indicator_sound_info_notification_get_volume_icon (VolumeControlActiveOutput active_output,
                                                   gdouble volume)
{
	const gchar* result;
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			if (volume <= 0.0) {
				result = "audio-volume-muted";
				return result;
			}
			if (volume <= 0.3) {
				result = "audio-volume-low";
				return result;
			}
			if (volume <= 0.7) {
				result = "audio-volume-medium";
				return result;
			}
			result = "audio-volume-high";
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

IndicatorSoundInfoNotification*
indicator_sound_info_notification_construct (GType object_type)
{
	IndicatorSoundInfoNotification * self = NULL;
	self = (IndicatorSoundInfoNotification*) indicator_sound_notification_construct (object_type);
	return self;
}

IndicatorSoundInfoNotification*
indicator_sound_info_notification_new (void)
{
	return indicator_sound_info_notification_construct (INDICATOR_SOUND_TYPE_INFO_NOTIFICATION);
}

static void
indicator_sound_info_notification_class_init (IndicatorSoundInfoNotificationClass * klass,
                                              gpointer klass_data)
{
	indicator_sound_info_notification_parent_class = g_type_class_peek_parent (klass);
	((IndicatorSoundNotificationClass *) klass)->create_notification = (NotifyNotification* (*) (IndicatorSoundNotification*)) indicator_sound_info_notification_real_create_notification;
}

static void
indicator_sound_info_notification_instance_init (IndicatorSoundInfoNotification * self,
                                                 gpointer klass)
{
}

static GType
indicator_sound_info_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorSoundInfoNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_sound_info_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorSoundInfoNotification), 0, (GInstanceInitFunc) indicator_sound_info_notification_instance_init, NULL };
	GType indicator_sound_info_notification_type_id;
	indicator_sound_info_notification_type_id = g_type_register_static (INDICATOR_SOUND_TYPE_NOTIFICATION, "IndicatorSoundInfoNotification", &g_define_type_info, 0);
	return indicator_sound_info_notification_type_id;
}

GType
indicator_sound_info_notification_get_type (void)
{
	static volatile gsize indicator_sound_info_notification_type_id__once = 0;
	if (g_once_init_enter (&indicator_sound_info_notification_type_id__once)) {
		GType indicator_sound_info_notification_type_id;
		indicator_sound_info_notification_type_id = indicator_sound_info_notification_get_type_once ();
		g_once_init_leave (&indicator_sound_info_notification_type_id__once, indicator_sound_info_notification_type_id);
	}
	return indicator_sound_info_notification_type_id__once;
}

