/* media-player.c generated by valac 0.56.12, the Vala compiler
 * generated from media-player.vala, do not modify */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Ted Gould <ted@canonical.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MEDIA_PLAYER (media_player_get_type ())
#define MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_PLAYER, MediaPlayer))
#define MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_PLAYER, MediaPlayerClass))
#define IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_PLAYER))
#define IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_PLAYER))
#define MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_PLAYER, MediaPlayerClass))

typedef struct _MediaPlayer MediaPlayer;
typedef struct _MediaPlayerClass MediaPlayerClass;
typedef struct _MediaPlayerPrivate MediaPlayerPrivate;

#define MEDIA_PLAYER_TYPE_TRACK (media_player_track_get_type ())
#define MEDIA_PLAYER_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrack))
#define MEDIA_PLAYER_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrackClass))
#define MEDIA_PLAYER_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MEDIA_PLAYER_TYPE_TRACK))
#define MEDIA_PLAYER_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MEDIA_PLAYER_TYPE_TRACK))
#define MEDIA_PLAYER_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrackClass))

typedef struct _MediaPlayerTrack MediaPlayerTrack;
typedef struct _MediaPlayerTrackClass MediaPlayerTrackClass;
enum  {
	MEDIA_PLAYER_0_PROPERTY,
	MEDIA_PLAYER_ID_PROPERTY,
	MEDIA_PLAYER_NAME_PROPERTY,
	MEDIA_PLAYER_STATE_PROPERTY,
	MEDIA_PLAYER_ICON_PROPERTY,
	MEDIA_PLAYER_DBUS_NAME_PROPERTY,
	MEDIA_PLAYER_IS_RUNNING_PROPERTY,
	MEDIA_PLAYER_CAN_RAISE_PROPERTY,
	MEDIA_PLAYER_CAN_DO_NEXT_PROPERTY,
	MEDIA_PLAYER_CAN_DO_PREV_PROPERTY,
	MEDIA_PLAYER_CAN_DO_PLAY_PROPERTY,
	MEDIA_PLAYER_CURRENT_TRACK_PROPERTY,
	MEDIA_PLAYER_NUM_PROPERTIES
};
static GParamSpec* media_player_properties[MEDIA_PLAYER_NUM_PROPERTIES];
typedef struct _MediaPlayerTrackPrivate MediaPlayerTrackPrivate;
enum  {
	MEDIA_PLAYER_TRACK_0_PROPERTY,
	MEDIA_PLAYER_TRACK_ARTIST_PROPERTY,
	MEDIA_PLAYER_TRACK_TITLE_PROPERTY,
	MEDIA_PLAYER_TRACK_ALBUM_PROPERTY,
	MEDIA_PLAYER_TRACK_ART_URL_PROPERTY,
	MEDIA_PLAYER_TRACK_NUM_PROPERTIES
};
static GParamSpec* media_player_track_properties[MEDIA_PLAYER_TRACK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MEDIA_PLAYER_PLAYLISTS_CHANGED_SIGNAL,
	MEDIA_PLAYER_PLAYBACKSTATUS_CHANGED_SIGNAL,
	MEDIA_PLAYER_NUM_SIGNALS
};
static guint media_player_signals[MEDIA_PLAYER_NUM_SIGNALS] = {0};

struct _MediaPlayer {
	GObject parent_instance;
	MediaPlayerPrivate * priv;
};

struct _MediaPlayerClass {
	GObjectClass parent_class;
	void (*activate) (MediaPlayer* self);
	void (*play_pause) (MediaPlayer* self);
	void (*next) (MediaPlayer* self);
	void (*previous) (MediaPlayer* self);
	guint (*get_n_playlists) (MediaPlayer* self);
	gchar* (*get_playlist_id) (MediaPlayer* self, gint index);
	gchar* (*get_playlist_name) (MediaPlayer* self, gint index);
	void (*activate_playlist_by_name) (MediaPlayer* self, const gchar* playlist);
	const gchar* (*get_id) (MediaPlayer* self);
	const gchar* (*get_name) (MediaPlayer* self);
	const gchar* (*get_state) (MediaPlayer* self);
	void (*set_state) (MediaPlayer* self, const gchar* value);
	GIcon* (*get_icon) (MediaPlayer* self);
	const gchar* (*get_dbus_name) (MediaPlayer* self);
	gboolean (*get_is_running) (MediaPlayer* self);
	gboolean (*get_can_raise) (MediaPlayer* self);
	gboolean (*get_can_do_next) (MediaPlayer* self);
	gboolean (*get_can_do_prev) (MediaPlayer* self);
	gboolean (*get_can_do_play) (MediaPlayer* self);
	MediaPlayerTrack* (*get_current_track) (MediaPlayer* self);
	void (*set_current_track) (MediaPlayer* self, MediaPlayerTrack* value);
};

struct _MediaPlayerTrack {
	GObject parent_instance;
	MediaPlayerTrackPrivate * priv;
};

struct _MediaPlayerTrackClass {
	GObjectClass parent_class;
};

struct _MediaPlayerTrackPrivate {
	gchar* _artist;
	gchar* _title;
	gchar* _album;
	gchar* _art_url;
};

static gpointer media_player_parent_class = NULL;
static gint MediaPlayerTrack_private_offset;
static gpointer media_player_track_parent_class = NULL;

VALA_EXTERN GType media_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaPlayer, g_object_unref)
VALA_EXTERN GType media_player_track_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaPlayerTrack, g_object_unref)
VALA_EXTERN void media_player_activate (MediaPlayer* self);
VALA_EXTERN void media_player_play_pause (MediaPlayer* self);
VALA_EXTERN void media_player_next (MediaPlayer* self);
VALA_EXTERN void media_player_previous (MediaPlayer* self);
VALA_EXTERN guint media_player_get_n_playlists (MediaPlayer* self);
VALA_EXTERN gchar* media_player_get_playlist_id (MediaPlayer* self,
                                     gint index);
VALA_EXTERN gchar* media_player_get_playlist_name (MediaPlayer* self,
                                       gint index);
VALA_EXTERN void media_player_activate_playlist_by_name (MediaPlayer* self,
                                             const gchar* playlist);
VALA_EXTERN const gchar* media_player_get_id (MediaPlayer* self);
VALA_EXTERN const gchar* media_player_get_name (MediaPlayer* self);
VALA_EXTERN const gchar* media_player_get_state (MediaPlayer* self);
VALA_EXTERN void media_player_set_state (MediaPlayer* self,
                             const gchar* value);
VALA_EXTERN GIcon* media_player_get_icon (MediaPlayer* self);
VALA_EXTERN const gchar* media_player_get_dbus_name (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_is_running (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_raise (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_do_next (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_do_prev (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_do_play (MediaPlayer* self);
VALA_EXTERN MediaPlayerTrack* media_player_get_current_track (MediaPlayer* self);
VALA_EXTERN void media_player_set_current_track (MediaPlayer* self,
                                     MediaPlayerTrack* value);
static void media_player_real_activate (MediaPlayer* self);
static void media_player_real_play_pause (MediaPlayer* self);
static void media_player_real_next (MediaPlayer* self);
static void media_player_real_previous (MediaPlayer* self);
static guint media_player_real_get_n_playlists (MediaPlayer* self);
static gchar* media_player_real_get_playlist_id (MediaPlayer* self,
                                          gint index);
static gchar* media_player_real_get_playlist_name (MediaPlayer* self,
                                            gint index);
static void media_player_real_activate_playlist_by_name (MediaPlayer* self,
                                                  const gchar* playlist);
static void media_player_not_implemented (MediaPlayer* self);
VALA_EXTERN MediaPlayer* media_player_construct (GType object_type);
VALA_EXTERN MediaPlayerTrack* media_player_track_new (const gchar* artist,
                                          const gchar* title,
                                          const gchar* album,
                                          const gchar* art_url);
VALA_EXTERN MediaPlayerTrack* media_player_track_construct (GType object_type,
                                                const gchar* artist,
                                                const gchar* title,
                                                const gchar* album,
                                                const gchar* art_url);
VALA_EXTERN const gchar* media_player_track_get_artist (MediaPlayerTrack* self);
static void media_player_track_set_artist (MediaPlayerTrack* self,
                                    const gchar* value);
VALA_EXTERN const gchar* media_player_track_get_title (MediaPlayerTrack* self);
static void media_player_track_set_title (MediaPlayerTrack* self,
                                   const gchar* value);
VALA_EXTERN const gchar* media_player_track_get_album (MediaPlayerTrack* self);
static void media_player_track_set_album (MediaPlayerTrack* self,
                                   const gchar* value);
VALA_EXTERN const gchar* media_player_track_get_art_url (MediaPlayerTrack* self);
static void media_player_track_set_art_url (MediaPlayerTrack* self,
                                     const gchar* value);
static void media_player_track_finalize (GObject * obj);
static GType media_player_track_get_type_once (void);
static void _vala_media_player_track_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_media_player_track_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static GType media_player_get_type_once (void);
static void _vala_media_player_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_media_player_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static void
media_player_real_activate (MediaPlayer* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_activate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_player_activate (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->activate) {
		_klass_->activate (self);
	}
}

static void
media_player_real_play_pause (MediaPlayer* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_play_pause'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_player_play_pause (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->play_pause) {
		_klass_->play_pause (self);
	}
}

static void
media_player_real_next (MediaPlayer* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_next'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_player_next (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->next) {
		_klass_->next (self);
	}
}

static void
media_player_real_previous (MediaPlayer* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_previous'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_player_previous (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->previous) {
		_klass_->previous (self);
	}
}

static guint
media_player_real_get_n_playlists (MediaPlayer* self)
{
	guint _tmp0_ = 0U;
	g_critical ("Type `%s' does not implement abstract method `media_player_get_n_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

guint
media_player_get_n_playlists (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_n_playlists) {
		return _klass_->get_n_playlists (self);
	}
	return 0U;
}

static gchar*
media_player_real_get_playlist_id (MediaPlayer* self,
                                   gint index)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_get_playlist_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
media_player_get_playlist_id (MediaPlayer* self,
                              gint index)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_playlist_id) {
		return _klass_->get_playlist_id (self, index);
	}
	return NULL;
}

static gchar*
media_player_real_get_playlist_name (MediaPlayer* self,
                                     gint index)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_get_playlist_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
media_player_get_playlist_name (MediaPlayer* self,
                                gint index)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_playlist_name) {
		return _klass_->get_playlist_name (self, index);
	}
	return NULL;
}

static void
media_player_real_activate_playlist_by_name (MediaPlayer* self,
                                             const gchar* playlist)
{
	g_critical ("Type `%s' does not implement abstract method `media_player_activate_playlist_by_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_player_activate_playlist_by_name (MediaPlayer* self,
                                        const gchar* playlist)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->activate_playlist_by_name) {
		_klass_->activate_playlist_by_name (self, playlist);
	}
}

static void
media_player_not_implemented (MediaPlayer* self)
{
	g_return_if_fail (self != NULL);
	g_warning ("media-player.vala:63: Property not implemented");
}

MediaPlayer*
media_player_construct (GType object_type)
{
	MediaPlayer * self = NULL;
	self = (MediaPlayer*) g_object_new (object_type, NULL);
	return self;
}

const gchar*
media_player_get_id (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_id) {
		return _klass_->get_id (self);
	}
	return NULL;
}

static const gchar*
media_player_real_get_id (MediaPlayer* base)
{
	const gchar* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = "";
	return result;
}

const gchar*
media_player_get_name (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_name) {
		return _klass_->get_name (self);
	}
	return NULL;
}

static const gchar*
media_player_real_get_name (MediaPlayer* base)
{
	const gchar* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = "";
	return result;
}

const gchar*
media_player_get_state (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_state) {
		return _klass_->get_state (self);
	}
	return NULL;
}

static const gchar*
media_player_real_get_state (MediaPlayer* base)
{
	const gchar* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = "";
	return result;
}

void
media_player_set_state (MediaPlayer* self,
                        const gchar* value)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->set_state) {
		_klass_->set_state (self, value);
	}
}

static void
media_player_real_set_state (MediaPlayer* base,
                             const gchar* value)
{
	MediaPlayer* self;
	self = base;
	g_object_notify_by_pspec ((GObject *) self, media_player_properties[MEDIA_PLAYER_STATE_PROPERTY]);
}

GIcon*
media_player_get_icon (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_icon) {
		return _klass_->get_icon (self);
	}
	return NULL;
}

static GIcon*
media_player_real_get_icon (MediaPlayer* base)
{
	GIcon* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = NULL;
	return result;
}

const gchar*
media_player_get_dbus_name (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_dbus_name) {
		return _klass_->get_dbus_name (self);
	}
	return NULL;
}

static const gchar*
media_player_real_get_dbus_name (MediaPlayer* base)
{
	const gchar* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = "";
	return result;
}

gboolean
media_player_get_is_running (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_is_running) {
		return _klass_->get_is_running (self);
	}
	return FALSE;
}

static gboolean
media_player_real_get_is_running (MediaPlayer* base)
{
	gboolean result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = FALSE;
	return result;
}

gboolean
media_player_get_can_raise (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_can_raise) {
		return _klass_->get_can_raise (self);
	}
	return FALSE;
}

static gboolean
media_player_real_get_can_raise (MediaPlayer* base)
{
	gboolean result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = FALSE;
	return result;
}

gboolean
media_player_get_can_do_next (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_can_do_next) {
		return _klass_->get_can_do_next (self);
	}
	return FALSE;
}

static gboolean
media_player_real_get_can_do_next (MediaPlayer* base)
{
	gboolean result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = FALSE;
	return result;
}

gboolean
media_player_get_can_do_prev (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_can_do_prev) {
		return _klass_->get_can_do_prev (self);
	}
	return FALSE;
}

static gboolean
media_player_real_get_can_do_prev (MediaPlayer* base)
{
	gboolean result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = FALSE;
	return result;
}

gboolean
media_player_get_can_do_play (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_can_do_play) {
		return _klass_->get_can_do_play (self);
	}
	return FALSE;
}

static gboolean
media_player_real_get_can_do_play (MediaPlayer* base)
{
	gboolean result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = FALSE;
	return result;
}

MediaPlayerTrack*
media_player_get_current_track (MediaPlayer* self)
{
	MediaPlayerClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->get_current_track) {
		return _klass_->get_current_track (self);
	}
	return NULL;
}

static MediaPlayerTrack*
media_player_real_get_current_track (MediaPlayer* base)
{
	MediaPlayerTrack* result;
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	result = NULL;
	return result;
}

void
media_player_set_current_track (MediaPlayer* self,
                                MediaPlayerTrack* value)
{
	MediaPlayerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MEDIA_PLAYER_GET_CLASS (self);
	if (_klass_->set_current_track) {
		_klass_->set_current_track (self, value);
	}
}

static void
media_player_real_set_current_track (MediaPlayer* base,
                                     MediaPlayerTrack* value)
{
	MediaPlayer* self;
	self = base;
	media_player_not_implemented (self);
	g_object_notify_by_pspec ((GObject *) self, media_player_properties[MEDIA_PLAYER_CURRENT_TRACK_PROPERTY]);
}

static inline gpointer
media_player_track_get_instance_private (MediaPlayerTrack* self)
{
	return G_STRUCT_MEMBER_P (self, MediaPlayerTrack_private_offset);
}

MediaPlayerTrack*
media_player_track_construct (GType object_type,
                              const gchar* artist,
                              const gchar* title,
                              const gchar* album,
                              const gchar* art_url)
{
	MediaPlayerTrack * self = NULL;
	g_return_val_if_fail (artist != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (album != NULL, NULL);
	g_return_val_if_fail (art_url != NULL, NULL);
	self = (MediaPlayerTrack*) g_object_new (object_type, "artist", artist, "title", title, "album", album, "art-url", art_url, NULL);
	return self;
}

MediaPlayerTrack*
media_player_track_new (const gchar* artist,
                        const gchar* title,
                        const gchar* album,
                        const gchar* art_url)
{
	return media_player_track_construct (MEDIA_PLAYER_TYPE_TRACK, artist, title, album, art_url);
}

const gchar*
media_player_track_get_artist (MediaPlayerTrack* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_artist;
	result = _tmp0_;
	return result;
}

static void
media_player_track_set_artist (MediaPlayerTrack* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_player_track_get_artist (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_artist);
		self->priv->_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_player_track_properties[MEDIA_PLAYER_TRACK_ARTIST_PROPERTY]);
	}
}

const gchar*
media_player_track_get_title (MediaPlayerTrack* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
media_player_track_set_title (MediaPlayerTrack* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_player_track_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_player_track_properties[MEDIA_PLAYER_TRACK_TITLE_PROPERTY]);
	}
}

const gchar*
media_player_track_get_album (MediaPlayerTrack* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}

static void
media_player_track_set_album (MediaPlayerTrack* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_player_track_get_album (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_album);
		self->priv->_album = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_player_track_properties[MEDIA_PLAYER_TRACK_ALBUM_PROPERTY]);
	}
}

const gchar*
media_player_track_get_art_url (MediaPlayerTrack* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_art_url;
	result = _tmp0_;
	return result;
}

static void
media_player_track_set_art_url (MediaPlayerTrack* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = media_player_track_get_art_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_art_url);
		self->priv->_art_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, media_player_track_properties[MEDIA_PLAYER_TRACK_ART_URL_PROPERTY]);
	}
}

static void
media_player_track_class_init (MediaPlayerTrackClass * klass,
                               gpointer klass_data)
{
	media_player_track_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MediaPlayerTrack_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_media_player_track_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_player_track_set_property;
	G_OBJECT_CLASS (klass)->finalize = media_player_track_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_TRACK_ARTIST_PROPERTY, media_player_track_properties[MEDIA_PLAYER_TRACK_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_TRACK_TITLE_PROPERTY, media_player_track_properties[MEDIA_PLAYER_TRACK_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_TRACK_ALBUM_PROPERTY, media_player_track_properties[MEDIA_PLAYER_TRACK_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_TRACK_ART_URL_PROPERTY, media_player_track_properties[MEDIA_PLAYER_TRACK_ART_URL_PROPERTY] = g_param_spec_string ("art-url", "art-url", "art-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
media_player_track_instance_init (MediaPlayerTrack * self,
                                  gpointer klass)
{
	self->priv = media_player_track_get_instance_private (self);
}

static void
media_player_track_finalize (GObject * obj)
{
	MediaPlayerTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrack);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_art_url);
	G_OBJECT_CLASS (media_player_track_parent_class)->finalize (obj);
}

static GType
media_player_track_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaPlayerTrackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_player_track_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaPlayerTrack), 0, (GInstanceInitFunc) media_player_track_instance_init, NULL };
	GType media_player_track_type_id;
	media_player_track_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaPlayerTrack", &g_define_type_info, 0);
	MediaPlayerTrack_private_offset = g_type_add_instance_private (media_player_track_type_id, sizeof (MediaPlayerTrackPrivate));
	return media_player_track_type_id;
}

GType
media_player_track_get_type (void)
{
	static volatile gsize media_player_track_type_id__once = 0;
	if (g_once_init_enter (&media_player_track_type_id__once)) {
		GType media_player_track_type_id;
		media_player_track_type_id = media_player_track_get_type_once ();
		g_once_init_leave (&media_player_track_type_id__once, media_player_track_type_id);
	}
	return media_player_track_type_id__once;
}

static void
_vala_media_player_track_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MediaPlayerTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrack);
	switch (property_id) {
		case MEDIA_PLAYER_TRACK_ARTIST_PROPERTY:
		g_value_set_string (value, media_player_track_get_artist (self));
		break;
		case MEDIA_PLAYER_TRACK_TITLE_PROPERTY:
		g_value_set_string (value, media_player_track_get_title (self));
		break;
		case MEDIA_PLAYER_TRACK_ALBUM_PROPERTY:
		g_value_set_string (value, media_player_track_get_album (self));
		break;
		case MEDIA_PLAYER_TRACK_ART_URL_PROPERTY:
		g_value_set_string (value, media_player_track_get_art_url (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_media_player_track_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MediaPlayerTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MEDIA_PLAYER_TYPE_TRACK, MediaPlayerTrack);
	switch (property_id) {
		case MEDIA_PLAYER_TRACK_ARTIST_PROPERTY:
		media_player_track_set_artist (self, g_value_get_string (value));
		break;
		case MEDIA_PLAYER_TRACK_TITLE_PROPERTY:
		media_player_track_set_title (self, g_value_get_string (value));
		break;
		case MEDIA_PLAYER_TRACK_ALBUM_PROPERTY:
		media_player_track_set_album (self, g_value_get_string (value));
		break;
		case MEDIA_PLAYER_TRACK_ART_URL_PROPERTY:
		media_player_track_set_art_url (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
media_player_class_init (MediaPlayerClass * klass,
                         gpointer klass_data)
{
	media_player_parent_class = g_type_class_peek_parent (klass);
	((MediaPlayerClass *) klass)->activate = (void (*) (MediaPlayer*)) media_player_real_activate;
	((MediaPlayerClass *) klass)->play_pause = (void (*) (MediaPlayer*)) media_player_real_play_pause;
	((MediaPlayerClass *) klass)->next = (void (*) (MediaPlayer*)) media_player_real_next;
	((MediaPlayerClass *) klass)->previous = (void (*) (MediaPlayer*)) media_player_real_previous;
	((MediaPlayerClass *) klass)->get_n_playlists = (guint (*) (MediaPlayer*)) media_player_real_get_n_playlists;
	((MediaPlayerClass *) klass)->get_playlist_id = (gchar* (*) (MediaPlayer*, gint)) media_player_real_get_playlist_id;
	((MediaPlayerClass *) klass)->get_playlist_name = (gchar* (*) (MediaPlayer*, gint)) media_player_real_get_playlist_name;
	((MediaPlayerClass *) klass)->activate_playlist_by_name = (void (*) (MediaPlayer*, const gchar*)) media_player_real_activate_playlist_by_name;
	MEDIA_PLAYER_CLASS (klass)->get_id = (const gchar* (*) (MediaPlayer*)) media_player_real_get_id;
	MEDIA_PLAYER_CLASS (klass)->get_name = (const gchar* (*) (MediaPlayer*)) media_player_real_get_name;
	MEDIA_PLAYER_CLASS (klass)->get_state = (const gchar* (*) (MediaPlayer*)) media_player_real_get_state;
	MEDIA_PLAYER_CLASS (klass)->set_state = (void (*) (MediaPlayer*, const gchar*)) media_player_real_set_state;
	MEDIA_PLAYER_CLASS (klass)->get_icon = (GIcon* (*) (MediaPlayer*)) media_player_real_get_icon;
	MEDIA_PLAYER_CLASS (klass)->get_dbus_name = (const gchar* (*) (MediaPlayer*)) media_player_real_get_dbus_name;
	MEDIA_PLAYER_CLASS (klass)->get_is_running = (gboolean (*) (MediaPlayer*)) media_player_real_get_is_running;
	MEDIA_PLAYER_CLASS (klass)->get_can_raise = (gboolean (*) (MediaPlayer*)) media_player_real_get_can_raise;
	MEDIA_PLAYER_CLASS (klass)->get_can_do_next = (gboolean (*) (MediaPlayer*)) media_player_real_get_can_do_next;
	MEDIA_PLAYER_CLASS (klass)->get_can_do_prev = (gboolean (*) (MediaPlayer*)) media_player_real_get_can_do_prev;
	MEDIA_PLAYER_CLASS (klass)->get_can_do_play = (gboolean (*) (MediaPlayer*)) media_player_real_get_can_do_play;
	MEDIA_PLAYER_CLASS (klass)->get_current_track = (MediaPlayerTrack* (*) (MediaPlayer*)) media_player_real_get_current_track;
	MEDIA_PLAYER_CLASS (klass)->set_current_track = (void (*) (MediaPlayer*, MediaPlayerTrack*)) media_player_real_set_current_track;
	G_OBJECT_CLASS (klass)->get_property = _vala_media_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_player_set_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_ID_PROPERTY, media_player_properties[MEDIA_PLAYER_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_NAME_PROPERTY, media_player_properties[MEDIA_PLAYER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_STATE_PROPERTY, media_player_properties[MEDIA_PLAYER_STATE_PROPERTY] = g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_ICON_PROPERTY, media_player_properties[MEDIA_PLAYER_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_DBUS_NAME_PROPERTY, media_player_properties[MEDIA_PLAYER_DBUS_NAME_PROPERTY] = g_param_spec_string ("dbus-name", "dbus-name", "dbus-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_IS_RUNNING_PROPERTY, media_player_properties[MEDIA_PLAYER_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_CAN_RAISE_PROPERTY, media_player_properties[MEDIA_PLAYER_CAN_RAISE_PROPERTY] = g_param_spec_boolean ("can-raise", "can-raise", "can-raise", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_CAN_DO_NEXT_PROPERTY, media_player_properties[MEDIA_PLAYER_CAN_DO_NEXT_PROPERTY] = g_param_spec_boolean ("can-do-next", "can-do-next", "can-do-next", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_CAN_DO_PREV_PROPERTY, media_player_properties[MEDIA_PLAYER_CAN_DO_PREV_PROPERTY] = g_param_spec_boolean ("can-do-prev", "can-do-prev", "can-do-prev", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_CAN_DO_PLAY_PROPERTY, media_player_properties[MEDIA_PLAYER_CAN_DO_PLAY_PROPERTY] = g_param_spec_boolean ("can-do-play", "can-do-play", "can-do-play", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_PLAYER_CURRENT_TRACK_PROPERTY, media_player_properties[MEDIA_PLAYER_CURRENT_TRACK_PROPERTY] = g_param_spec_object ("current-track", "current-track", "current-track", MEDIA_PLAYER_TYPE_TRACK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	media_player_signals[MEDIA_PLAYER_PLAYLISTS_CHANGED_SIGNAL] = g_signal_new ("playlists-changed", TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	media_player_signals[MEDIA_PLAYER_PLAYBACKSTATUS_CHANGED_SIGNAL] = g_signal_new ("playbackstatus-changed", TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
media_player_instance_init (MediaPlayer * self,
                            gpointer klass)
{
}

static GType
media_player_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaPlayer), 0, (GInstanceInitFunc) media_player_instance_init, NULL };
	GType media_player_type_id;
	media_player_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaPlayer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return media_player_type_id;
}

GType
media_player_get_type (void)
{
	static volatile gsize media_player_type_id__once = 0;
	if (g_once_init_enter (&media_player_type_id__once)) {
		GType media_player_type_id;
		media_player_type_id = media_player_get_type_once ();
		g_once_init_leave (&media_player_type_id__once, media_player_type_id);
	}
	return media_player_type_id__once;
}

static void
_vala_media_player_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_PLAYER, MediaPlayer);
	switch (property_id) {
		case MEDIA_PLAYER_ID_PROPERTY:
		g_value_set_string (value, media_player_get_id (self));
		break;
		case MEDIA_PLAYER_NAME_PROPERTY:
		g_value_set_string (value, media_player_get_name (self));
		break;
		case MEDIA_PLAYER_STATE_PROPERTY:
		g_value_set_string (value, media_player_get_state (self));
		break;
		case MEDIA_PLAYER_ICON_PROPERTY:
		g_value_set_object (value, media_player_get_icon (self));
		break;
		case MEDIA_PLAYER_DBUS_NAME_PROPERTY:
		g_value_set_string (value, media_player_get_dbus_name (self));
		break;
		case MEDIA_PLAYER_IS_RUNNING_PROPERTY:
		g_value_set_boolean (value, media_player_get_is_running (self));
		break;
		case MEDIA_PLAYER_CAN_RAISE_PROPERTY:
		g_value_set_boolean (value, media_player_get_can_raise (self));
		break;
		case MEDIA_PLAYER_CAN_DO_NEXT_PROPERTY:
		g_value_set_boolean (value, media_player_get_can_do_next (self));
		break;
		case MEDIA_PLAYER_CAN_DO_PREV_PROPERTY:
		g_value_set_boolean (value, media_player_get_can_do_prev (self));
		break;
		case MEDIA_PLAYER_CAN_DO_PLAY_PROPERTY:
		g_value_set_boolean (value, media_player_get_can_do_play (self));
		break;
		case MEDIA_PLAYER_CURRENT_TRACK_PROPERTY:
		g_value_set_object (value, media_player_get_current_track (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_media_player_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MediaPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_PLAYER, MediaPlayer);
	switch (property_id) {
		case MEDIA_PLAYER_STATE_PROPERTY:
		media_player_set_state (self, g_value_get_string (value));
		break;
		case MEDIA_PLAYER_CURRENT_TRACK_PROPERTY:
		media_player_set_current_track (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

